;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

;Button Types
Const ButtonMove=1
Const ButtonPush=2
Const ButtonHit=3
Const ButtonMoveCircle=4
Const ButtonRotate=5

;ActionTypes
Const ActionMove=1
Const ActionRotate=2

;Const Param
Const Param0=0
Const ParamX=1 ;Paramtre X
Const ParamY=2 ;Paramtre X
Const ParamZ=3 ;Paramtre X
Const ParamAX=4;Paramtre angle X
Const ParamAY=5;Paramtre angle Y
Const ParamAZ=6;Paramtre angle Z

;Coef de l'action de la souris sur le bouton
Const CoefMouseActionRot#=5
Const CoefMouseActionMove#=0.3

Const MaxHitTime=100

Type TActionObject
	Field ButtonType%
	Field Action%
	;Parametre de l'action
	Field AParam[3]
	Field XPos#,Ypos#,Zpos#
	Field XState#,YState#,ZState#,AngleX#,AngleY#,AngleZ#
	Field MaxX#,MinX#,MaxY#,MinY#,MaxZ#,MinZ#
	Field MaxAnglX#,MinAnglX#,MaxAnglY#,MinAnglY#,MaxAnglZ#,MinAnglZ#
	Field MaxSpeed#
	;origines du bouton (position par dfault)
	Field OrigX#,OrigY#,OrigZ#,OrigAnglX#,OrigAnglY#,OrigAnglZ#
	;puisance pour les boutons Hit et Push
	Field HitOrigin#
	Field HitPower#
	
	Field mesh%
	Field nbMoveObj%
	Field tabMovObj.TObjectCol[10] 
End Type

;bouton courrant sur lequel on est en train de faire l'action
Global CurrentAOB.TActionObject=Null 

;Gestion des boutons Hit
Global CurrentButtonHit.TActionObject=Null
Global TimeButtonDown%=0
Global StartTimeClick%=0

;----------------------------------------------------------------------
Function loadActionObject.TActionObject(path$)
	Local obj.TActionObject=New TActionObject
		
	fich=ReadFile(path)
	
	
	;Partie [Mesh]
	file_gotoSection(fich,"mesh")
	obj\mesh=LoadMesh(StrGetPath(path)+"\"+File_ReadString(fich))
	ScaleEntity(obj\mesh,coef,coef,coef)
	;cet objet sera sauveguard pour le replay
	TabRecObj[nbRecObj]=obj\mesh
	nbRecObj=nbRecObj+1
	
	EntityPickMode(obj\mesh,2)
	obj\Xpos=File_ReadFloat(fich)*coef
	obj\Ypos=File_ReadFloat(fich)*coef
	obj\Zpos=File_ReadFloat(fich)*coef
	PositionEntity(obj\mesh,obj\Xpos,obj\Ypos,obj\Zpos)
	
	;----------------------------
	;Partie [bounds]
	file_gotoSection(fich,"bounds")
	obj\MaxX=File_ReadFloat(fich)*coef
	obj\MinX=File_ReadFloat(fich)*coef
	obj\MaxY=File_ReadFloat(fich)*coef
	obj\MinY=File_ReadFloat(fich)*coef
	obj\MaxZ=File_ReadFloat(fich)*coef
	obj\MinZ=File_ReadFloat(fich)*coef
	obj\MaxAnglX=File_ReadFloat(fich)
	obj\MinAnglX=File_ReadFloat(fich)
	obj\MaxAnglY=File_ReadFloat(fich)
	obj\MinAnglY=File_ReadFloat(fich)
	obj\MaxAnglZ=File_ReadFloat(fich)
	obj\MinAnglZ=File_ReadFloat(fich)
	obj\MaxSpeed=File_ReadFloat(fich)*coef
	
	;----------------------------
	;Partie [buttonOrigin] Facultatif
	If file_SeekSection(fich,"buttonOrigin")
		obj\OrigX=File_ReadFloat(fich)*coef
		obj\OrigY=File_ReadFloat(fich)*coef
		obj\OrigZ=File_ReadFloat(fich)*coef
		obj\OrigAnglX=File_ReadFloat(fich)
		obj\OrigAnglY=File_ReadFloat(fich)
		obj\OrigAnglZ=File_ReadFloat(fich)
	EndIf 

	;----------------------------
	;Partie [buttonType]
	file_gotoSection(fich,"buttonType")
	Select (file_ReadString$(fich))
		Case "ButtonMove"
			obj\ButtonType=ButtonMove	
		Case "ButtonPush"
			obj\ButtonType=ButtonPush
			;obj\HitPower=File_ReadFloat(fich)
		Case "ButtonHit"
			obj\ButtonType=ButtonHit
			obj\HitPower=File_ReadFloat(fich)
			obj\HitOrigin=File_ReadFloat(fich)				
		Case "ButtonMoveCircle"
			obj\ButtonType=ButtonMoveCircle	
		Case "ButtonRotate"
			obj\ButtonType=ButtonRotate
		Default 
			RuntimeError "Unknow Button Type"
	End Select 
	;----------------------------
	;Partie [action]
	file_gotoSection(fich,"action")
	Select (file_ReadString$(fich))
		Case "ActionRotate"
			obj\Action=ActionRotate
		Case "ActionMove"
			obj\Action=ActionMove
		Default 
			RuntimeError "Unknow Acton Type"
	End Select 
	
	;lecture des parametres.
	For i=1 To 3
		Select (file_ReadString$(fich))
			Case "0"
				obj\Aparam[i]=Param0
			Case "X"
				obj\Aparam[i]=ParamX
			Case "Y"
				obj\Aparam[i]=ParamY
			Case "Z"
				obj\Aparam[i]=ParamZ
			Case "AX"
				obj\Aparam[i]=ParamAX
			Case "AY"
				obj\Aparam[i]=ParamAY
			Case "AZ"
				obj\Aparam[i]=ParamAZ
			Default 
				RuntimeError "Unknow Action Param"
		End Select 
	Next
	;----------------------------
	
	file_gotoSection(fich,"moveObject")
	i=1
	While (file_ReadString$(fich)<>"[endMove]")	
		;chargement de l'objet
		obj\tabMovObj[i]=loadObject(StrGetPath(path)+"\"+file_ReadString$(fich))
		;cet objet sera sauveguard pour le replay
		TabRecObj[nbRecObj]=obj\tabMovObj[i]\mesh
		nbRecObj=nbRecObj+1
		;crargement des coeficients de mouvements.
		obj\tabMovObj[i]\CoefMovX=File_ReadFloat(fich)
		obj\tabMovObj[i]\CoefMovY=File_ReadFloat(fich)
		obj\tabMovObj[i]\CoefMovZ=File_ReadFloat(fich)
		obj\tabMovObj[i]\CoefAngleMovX=File_ReadFloat(fich)
		obj\tabMovObj[i]\CoefAngleMovY=File_ReadFloat(fich)
		obj\tabMovObj[i]\CoefAngleMovZ=File_ReadFloat(fich)
		i=i+1		
	Wend 	
	obj\nbMoveObj=i-1
	CloseFile(fich)
	
	Return obj
End Function

;----------------------------------------------------------------------
; FONCTION DoMoveObject :
; Action : fait bouger le Bouton en fonction de ses parametres
;----------------------------------------------------------------------
Function DoMoveButton(obj.TActionObject,Xaction#,Yaction#,Zaction#)

	;Limitation de la Vitesse 
	If Abs(Xaction)>obj\maxSpeed Then Xaction=obj\maxSpeed*Sgn(Xaction)
	If Abs(Yaction)>obj\maxSpeed Then Yaction=obj\maxSpeed*Sgn(Yaction)
	If Abs(Zaction)>obj\maxSpeed Then Zaction=obj\maxSpeed*Sgn(Zaction)
	
	
	Select obj\ButtonType	
		
		Case ButtonMove,ButtonPush,ButtonHit;---------------------
			
			;Limitation par les bornes de l'action du boutton
			;X 
			obj\XState=obj\XState+Xaction
			If (obj\XState>obj\MaxX) Then obj\XState=obj\MaxX
			If (obj\XState<obj\MinX) Then obj\XState=obj\MinX
			;Y
			obj\YState=obj\YState+Yaction
			If (obj\YState>obj\MaxY) Then obj\YState=obj\MaxY
			If (obj\YState<obj\MinY) Then obj\YState=obj\MinY
			;Z
			obj\ZState=obj\ZState+Zaction
			If (obj\ZState>obj\MaxZ) Then obj\ZState=obj\MaxZ
			If (obj\ZState<obj\MinZ) Then obj\ZState=obj\MinZ
						
			;Dpalcement du bouton
			PositionEntity (obj\mesh,obj\Xpos+obj\XState,obj\Ypos+obj\YState,obj\Zpos+obj\ZState)
			
		Case ButtonMoveCircle;les limites de mouvement sont sphriques
	
			obj\XState=obj\XState+Xaction
			obj\YState=obj\YState+Yaction
			obj\ZState=obj\ZState+Zaction
			
			;Limitation par les bornes de l'action du boutton
			Local Yaw#=VectorYaw(obj\XState,obj\YState,obj\ZState)
			Local Pitch#=VectorPitch(obj\XState,obj\YState,obj\ZState)
			
			Local Xlimits#=-Sin(Yaw)*obj\MaxX
			Local Ylimits#=-Sin(Pitch)*obj\MaxY
			Local Zlimits#=Cos(Yaw)*obj\MaxZ
			
			If Abs(obj\XState)>Abs(Xlimits) Then obj\XState=Xlimits			
			If Abs(obj\YState)>Abs(Ylimits) Then obj\YState=Ylimits
			If Abs(obj\ZState)>Abs(Zlimits) Then obj\ZState=Zlimits
			
			;Dpalcement du bouton
			PositionEntity (obj\mesh,obj\Xpos+obj\XState,obj\Ypos+obj\YState,obj\Zpos+obj\ZState)
			
		Case ButtonRotate;---------------------
			;Limitation par les bornes de l'action du boutton
			;Y
			obj\AngleX=obj\AngleX+Yaction
			If (obj\AngleX>obj\MaxAnglX) Then obj\AngleX=obj\MaxAnglX
			If (obj\AngleX<obj\MinAnglX) Then obj\AngleX=obj\MinAnglX
			
			obj\AngleY=obj\AngleY+Zaction
			If (obj\AngleY>obj\MaxAnglY) Then obj\AngleY=obj\MaxAnglY
			If (obj\AngleY<obj\MinAnglY) Then obj\AngleY=obj\MinAnglY

			obj\AngleZ=obj\AngleZ+Xaction
			If (obj\AngleZ>obj\MaxAnglZ) Then obj\AngleZ=obj\MaxAnglZ
			If (obj\AngleZ<obj\MinAnglZ) Then obj\AngleZ=obj\MinAnglZ			
			
			;Rotation du bouton			
			RotateEntity (obj\mesh,obj\AngleX,obj\AngleY,-obj\AngleZ)	
						
	End Select
	
	UpdateObjectsFromButton(obj)
	
End Function

;----------------------------------------------------------
; Mise  jour des objets correspondants au bouton en fonction
; de la position du bouton
;----------------------------------------------------------
Function UpdateObjectsFromButton(obj.TActionObject)	
			
	Select (obj\Action)
		Case ActionRotate
			Local BtCoefMov#[6]
			BtCoefMov[0]=0
			For i=1 To obj\nbMoveObj
				BtCoefMov[ParamX]=(obj\xState/(obj\maxX-obj\minX))
				BtCoefMov[ParamY]=(obj\YState/(obj\maxY-obj\minY))
				BtCoefMov[ParamZ]=(obj\ZState/(obj\maxZ-obj\minZ))
				BtCoefMov[ParamAX]=(obj\AngleX/(obj\MaxAnglX-obj\MinAnglX))
				BtCoefMov[ParamAY]=(obj\AngleY/(obj\MaxAnglY-obj\MinAnglY))
				BtCoefMov[ParamAZ]=(obj\AngleZ/(obj\MaxAnglZ-obj\MinAnglZ))
		
				RotateObjectCol(obj\tabMovObj[i], obj\tabMovObj[i]\CoefAngleMovX * BtCoefMov[obj\AParam[1]] , obj\tabMovObj[i]\CoefAngleMovY * BtCoefMov[obj\AParam[2]] ,obj\tabMovObj[i]\CoefAngleMovZ * BtCoefMov[obj\AParam[3]])
			Next
		Case ActionMove
			;Local BtCoefMov#[6]
			BtCoefMov[0]=0
			For i=1 To obj\nbMoveObj
				BtCoefMov[ParamX]=(obj\xState/(obj\maxX-obj\minX))
				BtCoefMov[ParamY]=(obj\YState/(obj\maxY-obj\minY))
				BtCoefMov[ParamZ]=(obj\ZState/(obj\maxZ-obj\minZ))
				BtCoefMov[ParamAX]=(obj\AngleX/(obj\MaxAnglX-obj\MinAnglX))
				BtCoefMov[ParamAY]=(obj\AngleY/(obj\MaxAnglY-obj\MinAnglY))
				BtCoefMov[ParamAZ]=(obj\AngleZ/(obj\MaxAnglZ-obj\MinAnglZ))
		
				PositionObjectCol(obj\tabMovObj[i], obj\tabMovObj[i]\CoefMovX * BtCoefMov[obj\AParam[1]] , obj\tabMovObj[i]\CoefMovY * BtCoefMov[obj\AParam[2]] ,obj\tabMovObj[i]\CoefMovZ * BtCoefMov[obj\AParam[3]])
			Next
	End Select
	
End Function
;----------------------------------------------------------------------
; FONCTION GetActionObject:
; Action : Renvoie le TactionObject correspondant  l'objet 3D pass
; en parametre
;----------------------------------------------------------------------
Function GetActionObject.TActionObject(entit%)
	For obj.TActionObject = Each TActionObject
		If obj\mesh=entit Then Return obj
	Next
	Return Null
End Function 
;----------------------------------------------------------------
; Action de la souris sur les objets
;----------------------------------------------------------------
Function FUNC_MouseMoveObject()


	;-------Gestion des bouttons  Remetre en Place.---------------
	;si la liste n'est pas vide
	If Aob_TeteList<>Null Then 
		Aob_CurentPos=Aob_TeteList
		;pour chaque objet de la liste
		While Aob_CurentPos<>Null	
			Local Aob.TActionObject = Aob_CurentPos\Aob
			
			Local BoutonASaPlace=False
			
			Select Aob\ButtonType 
				;dans les cas de boutons qui se dplacent
				Case ButtonMove,ButtonPush,ButtonHit,ButtonMoveCircle
					DoMoveButton(Aob,aob\OrigX-aob\XState,aob\OrigY-aob\YState,aob\OrigZ-aob\ZState)
					BoutonASaPlace = (aob\XState=aob\OrigX) And (aob\YState=aob\OrigY) And (aob\ZState=aob\OrigZ)
				
				;dans les cas de boutons qui Tournent
				Case ButtonRotate
					DoMoveButton(Aob,aob\OrigAnglZ-aob\AngleZ,aob\OrigAnglX-aob\AngleX,aob\OrigAnglY-aob\AngleY)
					BoutonASaPlace = (aob\AngleX=aob\OrigAnglX) And (aob\AngleY=aob\OrigAnglY) And (aob\AngleZ=aob\OrigAnglZ)
			End Select
			
			; si le bouton est  sa place, on le supprime de la liste.
			If BoutonASaPlace Then	
				Local AobTemp.TCellAob=Aob_CurentPos
				Aob_CurentPos=Aob_CurentPos\suiv
				Aob_EffaceCell(AobTemp)
			Else
				Aob_CurentPos=Aob_CurentPos\suiv
			EndIf			
		Wend 		
	EndIf

	;-----------Choix du bouton  la souris---------
	If MouseDown(1) Then
		;on repre le bouton sur le quel on a cliqu.
		If (CurrentAOB=Null) Then 
			Local entit=CameraPick(camera,MouseX(),MouseY())
			If entit<>0 Then 
				CurrentAOB=GetActionObject(entit)
				StartTimeClick=MilliSecs()	
			EndIf
		EndIf
		;-----Exctution de l'action si on a choisis un bouton----------
		If (CurrentAOB<>Null) Then 
			Select CurrentAOB\ButtonType 
		
				Case ButtonHit:
					If MilliSecs()-StartTimeClick>=MaxHitTime Then 
							TimeButtonDown=MaxHitTime
							CurrentButtonHit=CurrentAOB
					EndIf
		
					Case ButtonPush:
						DoMoveButton(CurrentAOB,0,-1000,0)
	
					Default:
					;transformation des action de la souris dans le repre de la camra
						TFormVector (decalMouseX,-decalMouseY,0,camera,0)
						If (CurrentAOB\ButtonType=ButtonMove) Or (CurrentAOB\ButtonType=ButtonMoveCircle) 
							Local k#=CoefMouseActionMove
						Else 
		  					k#=CoefMouseActionRot
						EndIf 
						Local Xaction#=TFormedX()*mouseSpeed*k
						Local Yaction#=TFormedY()*mouseSpeed*k
						Local Zaction#=TFormedZ()*mouseSpeed*k
						; on execute l'action
						DoMoveButton(CurrentAOB,Xaction,Yaction,Zaction)
						MoveMouse MouseX()-decalMouseX,MouseY()-DecalMouseY ; on repalce la sourie l ou elle tait.	
			End Select			
		EndIf		
	Else ;on a relach le bouton
		If (CurrentAOB<>Null) Then 
		
			Select CurrentAOB\ButtonType 
				Case ButtonHit:
					If CurrentButtonHit=Null Then
						CurrentButtonHit=CurrentAOB
						TimeButtonDown%=MilliSecs()-StartTimeClick
					EndIf
				Case ButtonPush:
					Aob_AjouteList(CurrentAOB)
			End Select
			
		EndIf
		CurrentAOB=Null ;fin de l'action sur le bouton
	EndIf
	
	
	;------Gestion des BoutonsHit---------------------
	If CurrentButtonHit<>Null Then
	 	If MilliSecs()-StartTimeClick>=MaxHitTime Then TimeButtonDown=MaxHitTime							
	
		DoMoveButton(CurrentButtonHit,0,CurrentButtonHit\HitOrigin + CurrentButtonHit\HitPower*(MaxHitTime-TimeButtonDown),0)
		If Not MouseDown(1) Then  If CurrentButtonHit\YState=CurrentButtonHit\MinY Then	
			Aob_AjouteList(CurrentButtonHit)
			CurrentButtonHit=Null
		EndIf 
	EndIf 
		
	
End Function
;----------------------------------------------------------------
; Remet tous les boutons  leurs positions d'origine.
;----------------------------------------------------------------
Function ResetAllAob()
	For obj.TActionObject = Each TActionObject
		Aob_AjouteList(obj)
	Next
	;repositionement des freeObject
	ResetFreeObjet()
End Function