;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

;Movement Types
Const AniRotate=0
Const AniRotateReverse=1
Const AniTranslateReverse=2

Type TAnimObject
	Field ObjCol.TObjectCol
	
	Field AniType%
	
	;compteur du sinus pour la position\rotation de l'objet
	Field cptX#,cptY#,cptz#	
	;vitesse de variation du sinus
	Field SpdX#,SpdY#,spdZ#
	;Amplitude du mouvement de translation
	Field AmplX#,AmplY#,AmplZ#
	
	
	;angle de l'objet	
	Field Ax#,Ay#,Az#
	;Position de l'objet
	Field X#,Y#,Z#
	

End Type

;----------------------------------------------------------------------
Function loadAnimObject.TAnimObject(path$)
	Local AniObj.TAnimObject=New TAnimObject
	fich=ReadFile(path):If fich=0 Then RuntimeError("File not found '"+path+"'")
		;----------------------------
		;chargement de l'objet concern
		file_gotoSection(fich,"objectCol")	
			AniObj\ObjCol=LoadObject(StrGetPath(path)+"\"+file_readString(fich))

		;----------------------------
		; Partie du [Movement]	
		file_gotoSection(fich,"Movement")	
			;-Type du mouvement
			Select (file_ReadString$(fich))
			Case "AniRotate"
				AniObj\AniType=AniRotate	
				;-values
				AniObj\spdX=File_ReadFloat(fich)
				AniObj\spdY=File_ReadFloat(fich)
				AniObj\spdZ=File_ReadFloat(fich)
			Case "AniTranslateReverse"
				AniObj\AniType=AniTranslateReverse	
				;-values
				AniObj\spdX=File_ReadFloat(fich)
				AniObj\spdY=File_ReadFloat(fich)
				AniObj\spdZ=File_ReadFloat(fich)
				AniObj\AmplX=File_ReadFloat(fich)
				AniObj\AmplY=File_ReadFloat(fich)
				AniObj\AmplZ=File_ReadFloat(fich)
			Case "AniRotateReverse"
				AniObj\AniType=AniRotateReverse	
				;-values
				AniObj\spdX=File_ReadFloat(fich)
				AniObj\spdY=File_ReadFloat(fich)
				AniObj\spdZ=File_ReadFloat(fich)
				AniObj\AmplX=File_ReadFloat(fich)
				AniObj\AmplY=File_ReadFloat(fich)
				AniObj\AmplZ=File_ReadFloat(fich)
			Default 
				RuntimeError "Unknow Aniation Type"
			End Select			
			

			;cet objet sera sauveguard pour le replay
			TabRecObj[nbRecObj]=AniObj\ObjCol\mesh
			nbRecObj=nbRecObj+1					
			
	CloseFile(fich)
	Return AniObj

End Function	


;----------------------------------------------------------------------
Function updateAnimObject(animObj.TAnimObject)
			
	animObj\cptX=absMod(animObj\CptX+animObj\spdX,360)
	animObj\cptY=absMod(animObj\CptY+animObj\spdY,360)
	animObj\cptZ=absMod(animObj\CptZ+animObj\spdZ,360)

	Select animObj\AniType		
		;mouvements de rotation
		Case AniRotate :
			animObj\Ax=animObj\cptX
			animObj\Ay=animObj\cptY
			animObj\Az=animObj\cptZ
			RotateObjectCol(animObj\ObjCol,animObj\Ax,animObj\Ay,animObj\Az)	
		;Mouvements de Rotation all - retour
		Case AniRotateReverse
			animObj\Ax=Sin(animObj\cptX)*animObj\AmplX
			animObj\Ay=Sin(animObj\cptY)*animObj\AmplY
			animObj\Az=Sin(animObj\cptZ)*animObj\AmplZ
			RotateObjectCol(animObj\ObjCol,animObj\Ax,animObj\Ay,animObj\Az)
		;Mouvements de translation all - retour
		Case AniTranslateReverse :
			animObj\x=Sin(animObj\cptX)*animObj\AmplX
			animObj\y=Sin(animObj\cptY)*animObj\AmplY
			animObj\z=Sin(animObj\cptZ)*animObj\AmplZ
			positionObjectCol(animObj\ObjCol,animObj\X,animObj\y,animObj\Z)		
	End Select 
End Function

;----------------------------------------------------------------------

Function updateAnimObjects()
	For AnimObject.TAnimObject=Each TAnimObject
		updateAnimObject(AnimObject)
	Next
End Function