;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;
Include "util.bb"


;----------------------------------------------------------------------
; Fonction : file_gotoSection
; Action : positione le pointeur sur le ficher "fich" pass en parametre 
;		aprs la ligne gale  la chaine [rech]. si [rech] n'est pas trouv, 
;		renvoie un message d'erreur
;----------------------------------------------------------------------
Function file_gotoSection(fich,rech$)
	If Not file_seekSection(fich,rech) Then RuntimeError "Unable to find the field '["+rech+"]'"
End Function


;----------------------------------------------------------------------
; Fonction : file_SeekSection
; Action : positione le pointeur sur le ficher "fich" pass en parametre 
;		aprs la ligne gale  la chaine rech. si [rech] est trouv, renvoie 
;		vraie sinon faux.
;----------------------------------------------------------------------
Function file_SeekSection(fich,rech$)
	s$=""
	rech="["+Upper(rech)+"]"
	SeekFile(fich,0)

	While (Not Eof(fich)) And s<>rech
		s=Upper(file_ReadString(fich))
	Wend 
	Return Not Eof(fich) ;renvoie faux si non trouv, vrai sinon
End Function
;////////////////////////////////////////////////////////////////////////

;----------------------------------------------------------------------
; Fonction Accesseur : file_ReadString
; Action : Renvoie lachaine de caractre lue dans le fichier  la position en cours
;----------------------------------------------------------------------
Function file_ReadString$(fich)
	Local s$=ReadLine(fich)
	While StrStartWith(s,"//")
		s$=ReadLine(fich)
	Wend
	Return s
End Function

;----------------------------------------------------------------------
; Fonction Accesseur : file_ReadFloat
; Action : Renvoie le Dcimal correspondant  la chaine lue dans le fichier 
;		Fich pass en parametre  la position en cours
;----------------------------------------------------------------------
Function file_ReadFloat#(fich)
	Return StrToFloat(file_ReadString(fich))
End Function

;----------------------------------------------------------------------
; Fonction Accesseur : file_ReadInt
; Action : Renvoie l'entier correspondant  la chaine lue dans le fichier 
;		Fich pass en parametre  la position en cours
;----------------------------------------------------------------------
Function file_ReadInt%(fich)
	Return StrToInt(file_ReadString(fich))
End Function

;----------------------------------------------------------------------
; Fonction Accesseur : file_ReadBoolean
; Action : Renvoie lachaine de caractre lue dans le fichier  la position en cours
;----------------------------------------------------------------------
Function file_ReadBoolean(fich)
	Return StrToBoolean(file_ReadString(fich))
End Function

;////////////////////////////////////////////////////////////////////////

;----------------------------------------------------------------------
; Fonction Accesseur : file_ReadStringValue
; Action : Renvoie lachaine de caractre lue dans le fichier pour la valeur
; 'Value' de la section 'Section'
;----------------------------------------------------------------------
Function file_ReadStringValue$(fich,Section$,Value$)
	file_gotoSection(fich,Section)
	
	Repeat
		Local s$=File_ReadString(fich)
		;si on arrive en fin de section alors ERREUR
		If StrStartWith(s,"[") Or Eof(fich) Then  RuntimeError "Unable to find the value '"+value+"' in section "+"'["+Section+"]'"
		
	Until StrStartWith(Upper(s),Upper(Value)+"=") 
	
	Return StrGetValue(s)
End Function

;----------------------------------------------------------------------
; Fonction Accesseur : file_ReadFloatValue
; Action : Renvoie le Dcimale correspondant  la chaine lue dans le fichier 
; pour la valeur 'Value' de la section 'Section'
;----------------------------------------------------------------------
Function file_ReadFloatValue#(fich,Section$,Value$)
	Return StrToFloat(file_ReadStringValue(fich,Section$,Value$))
End Function

;----------------------------------------------------------------------
; Fonction Accesseur : file_ReadValueValue
; Action : Renvoie l'entier correspondant  la chaine lue dans le fichier 
; pour la valeur 'Value' de la section 'Section'
;----------------------------------------------------------------------
Function file_ReadIntValue%(fich,Section$,Value$)
	Return StrToInt(file_ReadStringValue(fich,Section$,Value$))
End Function