;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

;----------------------------------------------------------------------
Function loadObject.TObjectCol(path$)
	Local obj.TObjectCol=New TObjectCol
	
	
	fich=ReadFile(path):If fich=0 Then RuntimeError("File not found '"+path+"'")
	
	If file_SeekSection(fich,"FreeMobile") 
		obj\geomOnly=False
		Local JoinType=File_ReadInt(fich)
		Local JoinAngleX#=DegToRad(File_ReadFloat(fich))
		Local JoinAngleY#=DegToRad(File_ReadFloat(fich))
		Local JoinAngleZ#=DegToRad(File_ReadFloat(fich))
	Else 
		obj\geomOnly=True 
	EndIf
	
	;Partie [collisions] (1 ou plusieur cube)
	file_gotoSection(fich,"collision")
	Local i%=0
	obj\TabObjectCol[i]=readOde_Object(fich,obj\geomOnly)
	While obj\TabObjectCol[i]<>Null
		i=i+1
		obj\TabObjectCol[i]=readOde_Object(fich,obj\geomOnly)
	Wend 
	obj\NumObjectCol=i
	
	;Chargement de l'objet Visible	
	If file_SeekSection(fich,"mesh") Then
		obj\mesh=LoadMesh(StrGetPath(path)+"\"+File_ReadString(fich))
		ScaleEntity(obj\mesh,coef,coef,coef)
	Else
		obj\mesh=CreateMesh()
	EndIf
	
	;Chargement de la position de l'objet
	file_gotoSection(fich,"position")
		obj\x=File_ReadFloat(fich)*coef
		obj\y=File_ReadFloat(fich)*coef
		obj\z=File_ReadFloat(fich)*coef
		PositionObjectCol(obj,0,0,0)

	;chargement des aiments (Le 1er Ode_Object du tableau est considr comme Magnet) 
	If file_SeekSection(fich,"magnet")
		Local ObjIsMagnet=True
		magnet.TMagnet= New TMagnet
		magnet\ObjMagnet=obj\TabObjectCol[0]
		magnet\ZoneAction=File_ReadFloat(fich)*coef
		magnet\Force=File_ReadFloat(fich)*coef		
	EndIf 	
		
	;chargement de la texture
	If file_SeekSection(fich,"texture")
		Local texFlag=file_ReadInt(fich)		
		Local Env=LoadTexture(StrGetPath(path)+"\"+file_readString(fich),texFlag)
		Local indexTexture=file_ReadInt(fich)
		TextureBlend(env,1)
		EntityTexture(obj\mesh,env,0,indexTexture)
	EndIf 
	
	If file_SeekSection(fich,"shininess")
		EntityShininess( obj\mesh,File_ReadFloat(fich))	
	EndIf
	
	;Chargement de la couleur de l'objet
	If file_SeekSection(fich,"color")
		Local r%=file_ReadInt(fich)
		Local g%=file_ReadInt(fich)
		Local b%=file_ReadInt(fich)
		EntityColor (obj\mesh,r,g,b)
	EndIf
	
	update_all_objects()
	;gestion des objets libres physiquements.	
	If Not obj\geomOnly
		
		Local ODEobj1.Ode_object=obj\TabObjectCol[0]

		;"colage" des objets si les objets sont soumis  la 
		;physique pour ne fomer qu'un seul objet complexe form de cubes.
		For i=1 To obj\NumObjectCol-1
			ODE_CreateJoint(StaticID_OdeJoint,3 , New ODE_Joint ,ODEobj1\ODE_ID, obj\TabObjectCol[i]\ODE_ID,0 ,0 ,0 ,0 ,0 ,0 )
			StaticID_OdeJoint=StaticID_OdeJoint+1
		Next				
				
		;on relie le premier cube au dcor
		ODE_CreateJoint(StaticID_OdeJoint, JoinType , New ODE_Joint ,  ODEobj1\ODE_ID, -1 , obj\x, obj\Y, obj\Z,JoinAngleX ,JoinAngleY ,JoinAngleZ ) 
		StaticID_OdeJoint=StaticID_OdeJoint+1		
		
		;on relie la forme de l'objet aux cubes de colision
		EntityParent(obj\mesh,ODEobj1\mesh)	

		;cet objet sera sauveguard pour le replay
		TabRecObj[nbRecObj]=ODEobj1\mesh
		nbRecObj=nbRecObj+1				
	EndIf
	
	;sauvegauarde des objets actifs (qui doivent tres acualiss)
	If (Not obj\geomOnly) Or (ObjIsMagnet) Then
		;cet objet est un objet Actif
		TabActiveObjectCol[NbActiveObjectCol]=obj\TabObjectCol[0]
		NbActiveObjectCol=NbActiveObjectCol+1		
	EndIf			
			
	CloseFile(fich)
	Return obj
End Function

;----------------------------------------------------------------------
; FONCTION readOde_Object : 
; Action : Renvoie Un cube de collision ODE OBJET en foction des critres
; du fichier 'fich'  la positien en cours de lecture. Coef change la Taille 
; de l'objet. (Coef=1 ne change rien),si GeomOnly = true, alors, l'objet ne sera pas 
; soumis aux forces physiques, mais sera un obstacle pour les autres objets
;----------------------------------------------------------------------
Function readOde_Object.ODE_Object(fich,GeomOnly)
	If File_ReadString(Fich)="[endCollision]" Then 
		Return Null
	Else
		Local odeObj.ODE_Object = New ODE_Object
		
		;poid de l'objet
		Local OldPosition=FilePos(fich)
		If file_ReadString(fich)="[height]"
			Local Poid#=File_ReadFloat(fich)
		Else
			poid#=1
			SeekFile(fich,OldPosition)
		EndIf 
				
		Local x#=File_ReadFloat(fich)*coef
		Local y#=File_ReadFloat(fich)*coef
		Local z#=File_ReadFloat(fich)*coef
		odeObj\Xorig=x
		odeObj\Yorig=y
		odeObj\Zorig=z
		
		Local sizex#=File_ReadFloat(fich)*coef
		Local sizey#=File_ReadFloat(fich)*coef
		Local sizez#=File_ReadFloat(fich)*coef
		
		Local rotX#=degToRad(File_ReadFloat(fich))
		Local rotY#=degToRad(File_ReadFloat(fich))
		Local rotZ#=degToRad(File_ReadFloat(fich))
		odeObj\XAorig=rotX
		odeObj\YAorig=rotY
		odeObj\ZAorig=rotZ
		
		odeObj\obtype = 1
		ODE_CreateObject(odeObj\obtype , StaticID_OdeObject , odeObj, x , y , z , sizex , sizey , sizez , poid , GeomOnly)
		ODE_RotateObject(odeObj\ODE_ID , odeObj ,rotX,rotY,rotZ)
		EntityColor odeObj\mesh,0,255,255
		
		If objColVisible Then 
			EntityAlpha(odeObj\mesh,0.7)
		Else
			FreeEntity odeObj\mesh
			odeObj\mesh=CreateMesh()
		EndIf
		
		StaticID_OdeObject=StaticID_OdeObject+1
		Return odeObj
	EndIf
End Function