; Note : This file has been Modified for Ball Game Emulator and it is not the original.



;-----------------------------------------------------------------------------------------------------
;
;									O D E INTERFACE FUNCTIONS
;
;-----------------------------------------------------------------------------------------------------
;
;	ODE_CreateWorld()
;	ODE_DestroyWorld()
;	ODE_Worldstep(stepvalue#,mu#,mu2#,bounce#,bounce_vel#,soft_erp#,soft_cfm#,motion1#,motion2#,slip1#,slip2#)
;	ODE_SetWorldGravity(gravity#)
;
;	ODE_CreateObject(obtype , obnum , ob.ODE_Object , x# , z# , y# , sizex# , sizey# , sizez# , density# , geomonly )
;	ODE_DestroyObject( obnum , ob.ODE_Object )
;	ODE_PositionObject(obnum , ob.ODE_Object , x# , z# , y#)
;	ODE_RotateObject(obnum , ob.ODE_Object , xa# , ya# , za#)
;	ODE_SetBodyAngularVelocity(obnum , xvel# , yvel# , zvel#)
;	ODE_SetBodyLinearVelocity(obnum , xvel# , yvel# , zvel#)
;	ODE_Get_Object_Position(obnum , ob.ODE_Object)
;	ODE_Get_Object_Rotation(obnum , ob.ODE_Object)
;	ODE_Add_Force_Or_Torque_To_Object(obnum , xforce# , yforce# , zforce# , xtorque# , ytorque# , ztorque# , relative )
;	ODE_Add_Relative_Force_To_Object(obnum , xforce# , yforce# , zforce# , xpos# , ypos# , zpos# , relativemode )
;	ODE_Get_Object_Linear_Velocity(obnum , ob.ODE_Object)
;	ODE_Get_Object_Angular_Velocity(obnum , ob.ODE_Object)
;
;	ODE_CreateJoint( jointnum , jointtype , joint.ODE_Joint , jointob1 , jointob2 , anchorx# , anchory# , anchorz# , hingeaxisx# , hingeaxisy# , hingeaxisz# )
;	ODE_DestroyJoint( jointnum , joint.ODE_Joint )
;	ODE_Get_Number_Of_Object_Joints(obnum , ob.ODE_Object)
;	ODE_Get_Object_Joint_ID(obnum , ob.ODE_Object , index)
;	ODE_CreateCarWheelJoint( jointnum , jointtype , joint.ODE_Joint , jointob1,jointob2 , anchorx#,anchory#,anchorz# ,	hinge1axisx#,hinge1axisy#,hinge1axisz# , hinge2axisx#,hinge2axisy#,hinge2axisz# )
;	ODE_SetCarWheelJointParams( jointnum , jointtype , joint.ODE_Joint , jointob1,jointob2 ,p1#,p2#,p3#,p4#,p5#,p6#,p7#,p8#,p9# )
;	ODE_Get_Carwheel_Joint_Angle1(jointnum , joint.ODE_Joint)
;
;
;-----------------------------------------------------------------------------------------------------

;------------------------------------------------------------------------
;Open Dynamics Engine
;Copyright (c) 2001,2002, Russell L. Smith.
;All rights reserved.
;
;Redistribution And use in source And binary forms, with Or without
;modification, are permitted provided that the following conditions
;are met:
;
;Redistributions of source code must retain the above copyright notice,
;this list of conditions And the following disclaimer.
;
;Redistributions in binary form must reproduce the above copyright notice,
;this list of conditions And the following disclaimer in the documentation
;And/Or other materials provided with the distribution.
;
;Neither the names of ODE's copyright owner nor the names of its
;contributors may be used To endorse Or promote products derived from
;this software without specific prior written permission.
;
;THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS And CONTRIBUTORS
;"AS IS" And ANY EXPRESS Or IMPLIED WARRANTIES, INCLUDING, BUT Not
;LIMITED To, THE IMPLIED WARRANTIES OF MERCHANTABILITY And FITNESS
;For A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
;OWNER Or CONTRIBUTORS BE LIABLE For ANY DIRECT, INDIRECT, INCIDENTAL,
;SPECIAL, EXEMPLARY, Or CONSEQUENTIAL DAMAGES (INCLUDING, BUT Not LIMITED
;To, PROCUREMENT OF SUBSTITUTE GOODS Or SERVICES; LOSS OF USE, DATA, OR
;PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
;LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, Or TORT (INCLUDING
;NEGLIGENCE Or OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
;SOFTWARE, EVEN If ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;------------------------------------------------------------------------



Global DLLNAME$ = "ODE_DLL"

Const COLTYPE_sphere		= 1
Const COLTYPE_poly			= 2










;-------------------------------------------------------------------------------------------------
; O D E - Custom Types
;-------------------------------------------------------------------------------------------------

;CUSTOM TYPE - Object
Type ODE_Object
	Field active
	Field enabled
	Field obtype
	Field ODE_ID
	Field geomonly
	Field Xorig#,Yorig#,Zorig# ; rajout
	Field XAorig#,YAorig#,ZAorig# ; rajout
	Field x# , y# , z#
	Field safex#,safey#,safez#
	Field sizex# , sizey# , sizez#
	Field q1# , q2# , q3# , q4#
	Field xa# , ya# , za#
	Field mesh
	Field numattachedjoints
	Field jointatindex[10]
	Field linvelx# , linvely# , linvelz#
	Field angvelx# , angvely# , angvelz#
End Type


;CUSTOM TYPE - Joint
Type ODE_Joint
	Field active
	Field jtype
	Field ob1 , ob2
	Field hingeangle1#
End Type


;CUSTOM TYPE - collision
Type ODE_collision
	Field x# , y# , z#
	Field nx# , ny# , nz#
	Field depth#
	Field ob1 , ob2
End Type



;GLOBAL BANKS - for function input and output
Global mBankIn 							= CreateBank(60)
Global mBankOut 						= CreateBank(60)

;GLOBAL COLLISION STRUCTURES
Global GLOBALCOLCOUNT 					= 0
Dim GLOBALCOLS.ODE_collision(100)
For a=1 To 100
	GLOBALCOLS(a) = New ODE_collision
Next
Global GLOBALCOLSBANK					= CreateBank((100 * 9) * 4)












;-------------------------------------------------------------------------------------------------
; O D E - Access Functions To Physics System via DLL
;-------------------------------------------------------------------------------------------------







;--------------------------------------------------------------------------------------------------
;Access Function : CreateWorld : setup physics system and create space
Function ODE_CreateWorld()

	returned = CallDLL(DLLNAME$,"createworld")
	DLL_VERSION = returned
End Function
;--------------------------------------------------------------------------------------------------









;--------------------------------------------------------------------------------------------------
;Access Function : DestroyWorld : clear physics system world and space
Function ODE_DestroyWorld()

	returned = CallDLL(DLLNAME$,"destroyworld")

End Function
;--------------------------------------------------------------------------------------------------






;--------------------------------------------------------------------------------------------------
;Access Function : WorldStep : advance world by <stepvalue#>
Function ODE_Worldstep(stepvalue#,mu#,mu2#,bounce#,bounce_vel#,soft_erp#,soft_cfm#,motion1#,motion2#,slip1#,slip2#,flags)

;	Local mBankOut = CreateBank(4)
;	Local mBankIn = CreateBank(4)
	PokeFloat(mBankIn,0,stepvalue#)
	
	PokeFloat(mBankIn,4,mu#)
	PokeFloat(mBankIn,8,mu2#)
	PokeFloat(mBankIn,12,bounce#)
	PokeFloat(mBankIn,16,bounce_vel#)
	PokeFloat(mBankIn,20,soft_erp#)
	PokeFloat(mBankIn,24,soft_cfm#)
	PokeFloat(mBankIn,28,motion1#)
	PokeFloat(mBankIn,32,motion2#)
	PokeFloat(mBankIn,36,slip1#)
	PokeFloat(mBankIn,40,slip2#)
	PokeInt(mBankIn,44,flags)
		
	returned = CallDLL(DLLNAME$,"worldstep",mBankIn,mBankOut)

End Function
;--------------------------------------------------------------------------------------------------




;--------------------------------------------------------------------------------------------------
;Access Function : PrepCols - prepare the global collision list for creating contacts at worldstep
Function ODE_PrepCols(mu#,mu2#,bounce#,bounce_vel#,soft_erp#,soft_cfm#,motion1#,motion2#,slip1#,slip2#,flags)

	;reset the bank address counter to zero
	bankaddress = 0

	;store the number of contacts as the first bank entry
	PokeInt(GLOBALCOLSBANK,bankaddress,GLOBALCOLCOUNT)
	bankaddress = 48

	;store the collisions parameters
	PokeFloat(GLOBALCOLSBANK,4,mu#)
	PokeFloat(GLOBALCOLSBANK,8,mu2#)
	PokeFloat(GLOBALCOLSBANK,12,bounce#)
	PokeFloat(GLOBALCOLSBANK,16,bounce_vel#)
	PokeFloat(GLOBALCOLSBANK,20,soft_erp#)
	PokeFloat(GLOBALCOLSBANK,24,soft_cfm#)
	PokeFloat(GLOBALCOLSBANK,28,motion1#)
	PokeFloat(GLOBALCOLSBANK,32,motion2#)
	PokeFloat(GLOBALCOLSBANK,36,slip1#)
	PokeFloat(GLOBALCOLSBANK,40,slip2#)
	PokeInt(GLOBALCOLSBANK,44,flags)

	If (GLOBALCOLCOUNT>0)
		;cycle through all contacts and store their details
		For c=1 To GLOBALCOLCOUNT
			PokeFloat(GLOBALCOLSBANK,bankaddress,GLOBALCOLS(c)\x#)
			PokeFloat(GLOBALCOLSBANK,bankaddress+4,GLOBALCOLS(c)\y#)
			PokeFloat(GLOBALCOLSBANK,bankaddress+8,GLOBALCOLS(c)\z#)
			PokeFloat(GLOBALCOLSBANK,bankaddress+12,GLOBALCOLS(c)\nx#)
			PokeFloat(GLOBALCOLSBANK,bankaddress+16,GLOBALCOLS(c)\ny#)
			PokeFloat(GLOBALCOLSBANK,bankaddress+20,GLOBALCOLS(c)\nz#)
			PokeFloat(GLOBALCOLSBANK,bankaddress+24,GLOBALCOLS(c)\depth#)
			PokeInt(GLOBALCOLSBANK,bankaddress+28,GLOBALCOLS(c)\ob1)
			PokeInt(GLOBALCOLSBANK,bankaddress+32,GLOBALCOLS(c)\ob2)

;			DebugLog "Object Number :"+c
;			DebugLog PeekFloat(GLOBALCOLSBANK,bankaddress)
;			DebugLog PeekFloat(GLOBALCOLSBANK,bankaddress+4)
;			DebugLog PeekFloat(GLOBALCOLSBANK,bankaddress+8)
;			DebugLog PeekFloat(GLOBALCOLSBANK,bankaddress+12)
;			DebugLog PeekFloat(GLOBALCOLSBANK,bankaddress+16)
;			DebugLog PeekFloat(GLOBALCOLSBANK,bankaddress+20)
;			DebugLog PeekFloat(GLOBALCOLSBANK,bankaddress+24)
;			DebugLog PeekInt(GLOBALCOLSBANK,bankaddress+28)
;			DebugLog PeekInt(GLOBALCOLSBANK,bankaddress+32)
			
			bankaddress = bankaddress + 36


		Next
;		DebugLog "--------------------------------------------------"

	EndIf

	;call the DLL function			
	returned = CallDLL(DLLNAME$,"build_contacts",GLOBALCOLSBANK)
;	DebugLog returned
	
End Function
;--------------------------------------------------------------------------------------------------






;--------------------------------------------------------------------------------------------------
;Access Function : SetWorldGravity : adjust the gravity in the world
Function ODE_SetWorldGravity(gravity#)

;	Local mBankIn = CreateBank(36)
	PokeFloat(mBankIn,0,gravity#)		;gravity setting
	returned = CallDLL(DLLNAME$,"setworldgravity",mBankIn)

End Function
;--------------------------------------------------------------------------------------------------






;--------------------------------------------------------------------------------------------------
;Access Function 	: CreateObject 
;Purpose			: create a physics body
;Parameters 		:
;						object type : 1=cube  2=sphere 3=cylinder
;						ODE object ID number
;						object type instance
;						x pos
;						y pos
;						z pos
;						x size(cube)   /   radius(sphere)   /   radius(cylinder)
;						y size(cube)   /   height(cylinder)
;						z size(cube)
;						object density
;						static / dynamic : 0=dynamic object, 1=static object
;--------------------------------------------------------------------------------------------------
Function ODE_CreateObject(obtype , obnum , ob.ODE_Object , x# , y# , z# , sizex# , sizey# , sizez# , density# , geomonly )

;	Local mBankIn = CreateBank(40)
	PokeInt(mBankIn,0,obtype)		;object type
	PokeInt(mBankIn,4,obnum)		;object number
	PokeFloat(mBankIn,8,x#)			;position x
	PokeFloat(mBankIn,12,y#)		;position y
	PokeFloat(mBankIn,16,z#)		;posiiton z
	PokeFloat(mBankIn,20,sizex#)	;size x
	PokeFloat(mBankIn,24,sizey#)	;size y
	PokeFloat(mBankIn,28,sizez#)	;size z
	PokeFloat(mBankIn,32,density#)	;density
	PokeInt(mBankIn,36,geomonly)	;geom only flag
	
	returned = CallDLL(DLLNAME$,"createobject",mBankIn)

	ob\active = True
	ob\sizex# = sizex#
	ob\sizey# = sizey#
	ob\sizez# = sizez#
	ob\x# = x#
	ob\y# = y#
	ob\z# = z#
	ob\safex# = x#
	ob\safey# = y#
	ob\safez# = z#
	ob\geomonly = geomonly
	ob\enabled = 1
	ob\ODE_ID = obnum
	
	;create correct object mesh
	Select (obtype)

		;cube
		Case 1 :
			ob\mesh = CreateCube()
			FitMesh ob\mesh,-(ob\sizex#/2.0),-(ob\sizey#/2.0),-(ob\sizez#/2.0),ob\sizex#,ob\sizey#,ob\sizez#

		;sphere
		Case 2 :
			ob\mesh = CreateSphere()
			FitMesh ob\mesh,-ob\sizex#,-ob\sizex#,-ob\sizex#,(ob\sizex#*2.0),(ob\sizex#*2.0),(ob\sizex#*2.0)

		;cylinder
		Case 3 :
			ob\mesh = CreateCylinder()
			FitMesh ob\mesh,-ob\sizex#,-((ob\sizey#/2.0)+(ob\sizex#/2.0)),-ob\sizex#,(ob\sizex#*2.0),(ob\sizey# + ob\sizex#),(ob\sizex#*2.0)
			RotateMesh ob\mesh,0,90,0
		
	End Select
End Function
;--------------------------------------------------------------------------------------------------










;--------------------------------------------------------------------------------------------------
;Access Function 	: DestroyObject 
;Purpose			: destroy a physics body
;Parameters 		:
;						ODE object ID number
;						object type instance
;--------------------------------------------------------------------------------------------------
Function ODE_DestroyObject( obnum , ob.ODE_Object )

;	Local mBankIn = CreateBank(40)
	PokeInt(mBankIn,0,obnum)		;object number
	PokeInt(mBankIn,4,ob\geomonly)	;geom only flag

	If (ob\active)	
		returned = CallDLL(DLLNAME$,"destroyobject",mBankIn)
	EndIf

	ob\active = False
	ob\enabled = 0
	ob\ODE_ID = -1

End Function



;--------------------------------------------------------------------------------------------------
;Access Function 	: ODE_PositionObject
;Purpose			: position a physics body
;Parameters 		:
;						ODE object ID number
;						x position
;						y position
;						z position
;--------------------------------------------------------------------------------------------------
Function ODE_PositionObject(obnum , ob.ODE_Object , x# , y# , z#)

;	Local mBankIn = CreateBank(16)
	PokeInt(mBankIn,0,obnum)
	PokeFloat(mBankIn,4,x#)
	PokeFloat(mBankIn,8,y#)
	PokeFloat(mBankIn,12,z#)
	PokeInt(mBankIn,16,ob\geomonly)	;geom only flag

	returned = CallDLL(DLLNAME$,"positionobject",mBankIn)

	ob\x# = x#
	ob\y# = y#
	ob\z# = z#
	ob\safex# = x#
	ob\safey# = y#
	ob\safez# = z#
End Function
;--------------------------------------------------------------------------------------------------









;--------------------------------------------------------------------------------------------------
;Access Function 	: ODE_RotateObject
;Purpose			: rotate a physics body by specified euler angles (in radians)
;Parameters 		:
;						ODE object ID number
;						x rotation
;						y rotation
;						z rotation
;--------------------------------------------------------------------------------------------------
Function ODE_RotateObject(obnum , ob.ODE_Object , xa# , ya# , za#)

;	Local mBankIn = CreateBank(16)
	PokeInt(mBankIn,0,obnum)
	PokeFloat(mBankIn,4,xa#)
	PokeFloat(mBankIn,8,ya#)
	PokeFloat(mBankIn,12,za#)
	PokeInt(mBankIn,16,ob\geomonly)	;geom only flag

	returned = CallDLL(DLLNAME$,"rotateobject",mBankIn)
	
	ob\xa# = xa#
	ob\ya# = ya#
	ob\za# = za#

End Function
;--------------------------------------------------------------------------------------------------







;--------------------------------------------------------------------------------------------------
;Access Function 	: ODE_SetBodyAngularVelocity
;Purpose			: set the angular (x,y,z) velocities for a physics body
;Parameters 		:
;						ODE object ID number
;						x velocity
;						y velocity
;						z velocity
;--------------------------------------------------------------------------------------------------
Function ODE_SetBodyAngularVelocity(obnum , xvel# , yvel# , zvel#)

;	Local mBankIn = CreateBank(16)
	PokeInt(mBankIn,0,obnum)
	PokeFloat(mBankIn,4,xvel#)
	PokeFloat(mBankIn,8,yvel#)
	PokeFloat(mBankIn,12,zvel#)
	returned = CallDLL(DLLNAME$,"setbodyangularvelocity",mBankIn)

End Function
;--------------------------------------------------------------------------------------------------








;--------------------------------------------------------------------------------------------------
;Access Function 	: ODE_SetBodyLinearVelocity
;Purpose			: set the linear (x,y,z) velocities for a physics body
;Parameters 		:
;						ODE object ID number
;						x velocity
;						y velocity
;						z velocity
;--------------------------------------------------------------------------------------------------
Function ODE_SetBodyLinearVelocity(obnum , xvel# , yvel# , zvel#)

;	Local mBankIn = CreateBank(16)
	PokeInt(mBankIn,0,obnum)
	PokeFloat(mBankIn,4,xvel#)
	PokeFloat(mBankIn,8,yvel#)
	PokeFloat(mBankIn,12,zvel#)
	returned = CallDLL(DLLNAME$,"setbodylinearvelocity",mBankIn)

End Function
;--------------------------------------------------------------------------------------------------









;--------------------------------------------------------------------------------------------------
;Access Function : Get_Object_Position : obtains x#, y# and z# positions of object <obnum>
Function ODE_Get_Object_Position(obnum , ob.ODE_Object)

;	Local mBankOut = CreateBank(12)
;	Local mBankIn = CreateBank(12)
	PokeInt(mBankIn,0,obnum)

	If (ob\geomonly=0)
		PokeInt(mBankIn,4,0)
		returned = CallDLL(DLLNAME$,"get_object_position_component",mBankIn,mBankOut)
		ob\x# = PeekFloat(mBankOut,0)
	
		PokeInt(mBankIn,4,1)
		returned = CallDLL(DLLNAME$,"get_object_position_component",mBankIn,mBankOut)
		ob\y# = PeekFloat(mBankOut,0)

		PokeInt(mBankIn,4,2)
		returned = CallDLL(DLLNAME$,"get_object_position_component",mBankIn,mBankOut)
		ob\z# = PeekFloat(mBankOut,0)
	Else
	
	EndIf
	
	PositionEntity ob\mesh , ob\x# , ob\y# , ob\z# , True

End Function
;--------------------------------------------------------------------------------------------------









;--------------------------------------------------------------------------------------------------
;Access Function : Get_Object_Rotation : obtains xa#, ya# and za# rotations of object <obnum>
Function ODE_Get_Object_Rotation(obnum , ob.ODE_Object)
	
;	Local mBankOut = CreateBank(12)
;	Local mBankIn = CreateBank(12)
	PokeInt(mBankIn,0,obnum)

	PokeInt(mBankIn,4,0)
	PokeInt(mBankIn,8,ob\geomonly)	;geom only flag
	returned = CallDLL(DLLNAME$,"get_object_rotation_component",mBankIn,mBankOut)
	ob\q1# = PeekFloat(mBankOut,0)

	PokeInt(mBankIn,4,1)
	PokeInt(mBankIn,8,ob\geomonly)	;geom only flag
	returned = CallDLL(DLLNAME$,"get_object_rotation_component",mBankIn,mBankOut)
	ob\q2# = PeekFloat(mBankOut,0)

	PokeInt(mBankIn,4,2)
	PokeInt(mBankIn,8,ob\geomonly)	;geom only flag
	returned = CallDLL(DLLNAME$,"get_object_rotation_component",mBankIn,mBankOut)
	ob\q3# = PeekFloat(mBankOut,0)

	PokeInt(mBankIn,4,3)
	PokeInt(mBankIn,8,ob\geomonly)	;geom only flag
	returned = CallDLL(DLLNAME$,"get_object_rotation_component",mBankIn,mBankOut)
	ob\q4# = PeekFloat(mBankOut,0)
	
	tempx# = EntityX#(ob\mesh,True)
	tempy# = EntityY#(ob\mesh,True)
	tempz# = EntityZ#(ob\mesh,True)
	PositionEntity ob\mesh,0,0,0
	PositionEntity ODE_tempPivot,0,0,0
    RotateEntity ob\mesh, 0, 0, 0
   	AlignToVector ODE_tempPivot, -ob\q2# , -ob\q4#, -ob\q3#, 3    ; aim z-axis...
    EntityParent ob\mesh, ODE_tempPivot
   	TurnEntity ODE_tempPivot, 0, 0, 2 * ACos( ob\q1# )
    EntityParent ob\mesh, 0        ; undo parent / child relationship
	PositionEntity ob\mesh,tempx#,tempy#,tempz#

	ob\xa# = EntityPitch(ob\mesh,1)	
	ob\ya# = EntityYaw(ob\mesh,1)	
	ob\za# = EntityRoll(ob\mesh,1)	

End Function
;--------------------------------------------------------------------------------------------------








;--------------------------------------------------------------------------------------------------
;Access Function 	: ODE_Add_Force_Or_Torque_To_Object
;Purpose			: adds worldspace or relative forces or torques to a physics body
;Parameters 		:
;						ODE object ID number
;						x force
;						y force
;						z force
;						x torque
;						y torque
;						z torque
;						relative flag
;--------------------------------------------------------------------------------------------------
Function ODE_Add_Force_Or_Torque_To_Object(obnum , xforce# , yforce# , zforce# , xtorque# , ytorque# , ztorque# , relative )

;	Local mBankIn = CreateBank(32)
	PokeInt(mBankIn,0,obnum)
	PokeFloat(mBankIn,4,xforce#)
	PokeFloat(mBankIn,8,yforce#)
	PokeFloat(mBankIn,12,zforce#)
	PokeFloat(mBankIn,16,xtorque#)
	PokeFloat(mBankIn,20,ytorque#)
	PokeFloat(mBankIn,24,ztorque#)
	PokeInt(mBankIn,28,relative)
	
	returned = CallDLL(DLLNAME$,"add_force_or_torque_to_object",mBankIn)

End Function
;--------------------------------------------------------------------------------------------------










;--------------------------------------------------------------------------------------------------
;Access Function 	: ODE_Add_Relative_Force_To_Object
;Purpose			: adds worldspace or relative forces to a physics body, selectable mode
;Parameters 		:
;						ODE object ID number
;						x force
;						y force
;						z force
;						x position for force
;						y position for force
;						z position for force
;						relative mode -
;								1 = add force at pos
;								2 = add force at rel pos
;								3 = add rel force at pos
;								4 = add rel force at rel pos
;--------------------------------------------------------------------------------------------------
Function ODE_Add_Relative_Force_To_Object(obnum , xforce# , yforce# , zforce# , xpos# , ypos# , zpos# , relativemode )

;	Local mBankIn = CreateBank(32)
	PokeInt(mBankIn,0,obnum)
	PokeFloat(mBankIn,4,xforce#)
	PokeFloat(mBankIn,8,yforce#)
	PokeFloat(mBankIn,12,zforce#)
	PokeFloat(mBankIn,16,xpos#)
	PokeFloat(mBankIn,20,ypos#)
	PokeFloat(mBankIn,24,zpos#)
	PokeInt(mBankIn,28,relativemode)
	
	returned = CallDLL(DLLNAME$,"add_force_to_object_at_rel_pos",mBankIn)

End Function
;--------------------------------------------------------------------------------------------------








;--------------------------------------------------------------------------------------------------
;Access Function : Get_Object_Linear_Velocity : obtains x#, y# and z# linear vels of object <obnum>
Function ODE_Get_Object_Linear_Velocity(obnum , ob.ODE_Object)

;	Local mBankOut = CreateBank(12)
;	Local mBankIn = CreateBank(12)
	PokeInt(mBankIn,0,obnum)

	If (ob\geomonly=0)
		PokeInt(mBankIn,4,0)
		returned = CallDLL(DLLNAME$,"get_object_linear_velocity_component",mBankIn,mBankOut)
		ob\linvelx# = PeekFloat(mBankOut,0)
	
		PokeInt(mBankIn,4,1)
		returned = CallDLL(DLLNAME$,"get_object_linear_velocity_component",mBankIn,mBankOut)
		ob\linvely# = PeekFloat(mBankOut,0)

		PokeInt(mBankIn,4,2)
		returned = CallDLL(DLLNAME$,"get_object_linear_velocity_component",mBankIn,mBankOut)
		ob\linvelz# = PeekFloat(mBankOut,0)
	Else
	
	EndIf

End Function
;--------------------------------------------------------------------------------------------------







;--------------------------------------------------------------------------------------------------
;Access Function : Get_Object_Angular_Velocity : obtains x#, y# and z# angular vels of object <obnum>
Function ODE_Get_Object_Angular_Velocity(obnum , ob.ODE_Object)

;	Local mBankOut = CreateBank(12)
;	Local mBankIn = CreateBank(12)
	PokeInt(mBankIn,0,obnum)

	If (ob\geomonly=0)
		PokeInt(mBankIn,4,0)
		returned = CallDLL(DLLNAME$,"get_object_angular_velocity_component",mBankIn,mBankOut)
		ob\angvelx# = PeekFloat(mBankOut,0)
	
		PokeInt(mBankIn,4,1)
		returned = CallDLL(DLLNAME$,"get_object_angular_velocity_component",mBankIn,mBankOut)
		ob\angvely# = PeekFloat(mBankOut,0)

		PokeInt(mBankIn,4,2)
		returned = CallDLL(DLLNAME$,"get_object_angular_velocity_component",mBankIn,mBankOut)
		ob\angvelz# = PeekFloat(mBankOut,0)
	Else
	
	EndIf

End Function
;--------------------------------------------------------------------------------------------------







;--------------------------------------------------------------------------------------------------
;Access Function 	: ODE_Enable_Or_Disable_Object
;Purpose			: enable or disable an ODE object
;Parameters 		:
;						ODE object ID number
;						Blitz object
;						flag -
;							1 = enable
;							0 = disable
;--------------------------------------------------------------------------------------------------
Function ODE_Enable_Or_Disable_Object(obnum , ob.ODE_Object , flag )

	PokeInt(mBankIn,0,obnum)
	PokeInt(mBankIn,4,flag)

	returned = CallDLL(DLLNAME$,"enable_or_disable_object",mBankIn)
	
	ob\enabled = flag

End Function
;--------------------------------------------------------------------------------------------------








;--------------------------------------------------------------------------------------------------
;Access Function 	: CreateJoint
;Purpose			: create a physics joint
;Parameters 		:
;						ODE joint ID number
;						ODE joint type
;							1 = ball and socket
;							2 = hinge
;							3 = fixed
;						Blitz joint object for data storage
;						ODE jointed object ID 1
;						ODE jointed object ID 2
;						joint anchor x position
;						joint anchor y position
;						joint anchor z position
;						hinge joint only - axis x
;						hinge joint only - axis y
;						hinge joint only - axis z
;--------------------------------------------------------------------------------------------------
Function ODE_CreateJoint( jointnum , jointtype , joint.ODE_Joint , jointob1 , jointob2 , anchorx# , anchory# , anchorz# , hingeaxisx# , hingeaxisy# , hingeaxisz# )

;	Local mBankIn = CreateBank(40)
	PokeInt(mBankIn,0,jointnum)		;joint number
	PokeInt(mBankIn,4,jointtype)	;joint type
	PokeInt(mBankIn,8,jointob1)		;jointed object 1
	PokeInt(mBankIn,12,jointob2)	;jointed object 2

	PokeFloat(mBankIn,16,anchorx#)		;anchor x position
	PokeFloat(mBankIn,20,anchory#)		;anchor y position
	PokeFloat(mBankIn,24,anchorz#)		;anchor z position

	PokeFloat(mBankIn,28,hingeaxisx#)	;hinge x axis
	PokeFloat(mBankIn,32,hingeaxisy#)	;hinge y axis
	PokeFloat(mBankIn,36,hingeaxisz#)	;hinge z axis

	returned = CallDLL(DLLNAME$,"createjoint",mBankIn)

	joint\jtype = jointtype
	joint\ob1 = jointob1
	joint\ob2 = jointob2
	joint\active = True

End Function
;--------------------------------------------------------------------------------------------------








;--------------------------------------------------------------------------------------------------
;Access Function 	: DestroyJoint
;Purpose			: destroy a physics joint
;Parameters 		:
;						ODE joint ID number
;--------------------------------------------------------------------------------------------------
Function ODE_DestroyJoint( jointnum , joint.ODE_Joint )

;	Local mBankIn = CreateBank(4)
	If (joint<>Null)
		PokeInt(mBankIn,0,jointnum)		;joint number

		returned = CallDLL(DLLNAME$,"destroyjoint",mBankIn)

		joint\active = False
		Delete joint
	EndIf
	
End Function












;--------------------------------------------------------------------------------------------------
;Access Function 	: Get_Number_Of_Object_Joints
;Purpose			: obtain the number of joints attached to an object
;Parameters 		:
;						ODE object ID number
;						Blitz object
;--------------------------------------------------------------------------------------------------
Function ODE_Get_Number_Of_Object_Joints(obnum , ob.ODE_Object)

;	Local mBankOut = CreateBank(4)
;	Local mBankIn = CreateBank(4)

	PokeInt(mBankIn,0,obnum)

	returned = CallDLL(DLLNAME$,"get_number_of_object_joints",mBankIn,mBankOut)
	ob\numattachedjoints = PeekInt(mBankOut,0)

End Function






;--------------------------------------------------------------------------------------------------
;Access Function 	: Get_Object_Joint_ID
;Purpose			: obtain the ID number of a joint attached to an object at a specific index
;Parameters 		:
;						ODE object ID number
;						Blitz object
;						requested index
;--------------------------------------------------------------------------------------------------
Function ODE_Get_Object_Joint_ID(obnum , ob.ODE_Object , index)

;	Local mBankOut = CreateBank(4)
;	Local mBankIn = CreateBank(8)

	PokeInt(mBankIn,0,obnum)
	PokeInt(mBankIn,4,index)

	returned = CallDLL(DLLNAME$,"get_object_joint_id",mBankIn,mBankOut)

	ob\jointatindex[index] = PeekInt(mBankOut,0)

End Function










;--------------------------------------------------------------------------------------------------
;Access Function 	: CreateCarWheelJoint
;Purpose			: create a carwheel (hinge2) physics joint
;Parameters 		:
;						ODE joint ID number
;						ODE joint type
;							1 = ball and socket
;							2 = hinge
;						Blitz joint object for data storage
;						ODE jointed object ID 1
;						ODE jointed object ID 2
;						joint anchor x position
;						joint anchor y position
;						joint anchor z position
;						hinge joint only - axis x
;						hinge joint only - axis y
;						hinge joint only - axis z
;--------------------------------------------------------------------------------------------------
Function ODE_CreateCarWheelJoint( jointnum , jointtype , joint.ODE_Joint , jointob1,jointob2 , anchorx#,anchory#,anchorz# ,	hinge1axisx#,hinge1axisy#,hinge1axisz# , hinge2axisx#,hinge2axisy#,hinge2axisz# )

;	Local mBankIn = CreateBank(52)
	PokeInt(mBankIn,0,jointnum)		;joint number
	PokeInt(mBankIn,4,jointtype)	;joint type
	PokeInt(mBankIn,8,jointob1)		;jointed object 1
	PokeInt(mBankIn,12,jointob2)	;jointed object 2

	PokeFloat(mBankIn,16,anchorx#)		;anchor x position
	PokeFloat(mBankIn,20,anchory#)		;anchor y position
	PokeFloat(mBankIn,24,anchorz#)		;anchor z position

	PokeFloat(mBankIn,28,hinge1axisx#)	;hinge x axis 1
	PokeFloat(mBankIn,32,hinge1axisy#)	;hinge y axis 1
	PokeFloat(mBankIn,36,hinge1axisz#)	;hinge z axis 1

	PokeFloat(mBankIn,40,hinge2axisx#)	;hinge x axis 2
	PokeFloat(mBankIn,44,hinge2axisy#)	;hinge y axis 2
	PokeFloat(mBankIn,48,hinge2axisz#)	;hinge z axis 2

	returned = CallDLL(DLLNAME$,"createcarwheeljoint",mBankIn)

	joint\jtype = jointtype
	joint\ob1 = jointob1
	joint\ob2 = jointob2
	joint\active = True
	
End Function
;--------------------------------------------------------------------------------------------------










;--------------------------------------------------------------------------------------------------
;Access Function 	: SetCarWheelJointParams
;Purpose			: adjust the carwheel (hinge2) physics joint parameters
;Parameters 		:
;						ODE joint ID number
;						ODE joint type
;							1 = ball and socket
;							2 = hinge
;						Blitz joint object for data storage
;						ODE jointed object ID 1
;						ODE jointed object ID 2
;						dParamVel
;						dParamFMax
;						dParamLoStop
;						dParamHiStop
;						dParamFudgeFactor
;						dParamVel2
;						dParamFMax2
;						dParamSuspensionERP
;						dParamSuspensionCFM
;--------------------------------------------------------------------------------------------------
Function ODE_SetCarWheelJointParams( jointnum , jointtype , joint.ODE_Joint , jointob1,jointob2 ,p1#,p2#,p3#,p4#,p5#,p6#,p7#,p8#,p9# )

;	Local mBankIn = CreateBank(52)
	PokeInt(mBankIn,0,jointnum)		;joint number
	PokeInt(mBankIn,4,jointtype)	;joint type
	PokeInt(mBankIn,8,jointob1)		;jointed object 1
	PokeInt(mBankIn,12,jointob2)	;jointed object 2

	PokeFloat(mBankIn,16,p1#)		;dparamVel
	PokeFloat(mBankIn,20,p2#)		;dparamFMax
	PokeFloat(mBankIn,24,p3#)		;dparamLoStop
	PokeFloat(mBankIn,28,p4#)		;dparamHiStop
	PokeFloat(mBankIn,32,p5#)		;dparamFudgeFactor
	PokeFloat(mBankIn,36,p6#)		;dparamVel2
	PokeFloat(mBankIn,40,p7#)		;dparamFMax2
	PokeFloat(mBankIn,44,p8#)		;dparamSuspensionERP
	PokeFloat(mBankIn,48,p9#)		;dparamSuspensionCFM

	returned = CallDLL(DLLNAME$,"setcarwheeljointparams",mBankIn)

End Function







;--------------------------------------------------------------------------------------------------
;Access Function 	: Get_Carwheel_Joint_Angle1
;Purpose			: obtain the angle of the angle1 part of a carwheel joint
;Parameters 		:
;						ODE joint ID number
;						Blitz joint object
;--------------------------------------------------------------------------------------------------
Function ODE_Get_Carwheel_Joint_Angle1(jointnum , joint.ODE_Joint)

;	Local mBankOut = CreateBank(4)
;	Local mBankIn = CreateBank(4)

	PokeInt(mBankIn,0,jointnum)

	returned = CallDLL(DLLNAME$,"get_carwheel_joint_angle1",mBankIn,mBankOut)

	joint\hingeangle1# = PeekFloat(mBankOut,0)

End Function