;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

;----------------------------------------------------------------------
;	Fonctions Mathematiques
;----------------------------------------------------------------------
Function RadToDeg#(rad#)
	Return Rad*180/Pi 
End Function
;----------------------------------------------------------------------
Function DegToRad#(deg#)
	Return Deg*Pi/180 
End Function
;----------------------------------------------------------------------
Function AbsMod#(Value#,modulo#)
	Return ((value Mod modulo) + modulo ) Mod modulo
End Function
;----------------------------------------------------------------------
;----------------------------------------------------------------------
;----------------------------------------------------------------------
;;
:;				            S T R I G S
;;
;----------------------------------------------------------------------
;----------------------------------------------------------------------
Function StrGetPath$(path$)
	Local pos%=StrFindLast(path,"\")
	If pos=0 Then 
		Return ""
	Else 
		Return Left(path$,pos-1) 
	EndIf
End Function
;----------------------------------------------------------------------
; Fonction StrFindLast : renvoie la deriere position de la chaine 'seek'
; prsente dans la chaine 'st'. renvoie 0 si non trouv
;----------------------------------------------------------------------
Function StrFindLast%(st$,seek$)
	Local res%=0
	Local pos%=1
	pos = Instr(st,seek,pos)
	
	If pos = 0 Then
		Return 0
	Else
		While pos<>0
			res=pos
			pos = Instr(st,seek,pos+1) 
		Wend
		Return res
	EndIf
			  
End Function
;----------------------------------------------------------------------
Function StrStartWith(St$,with$)
	Return Instr(St$,with$)=1 
End Function

;----------------------------------------------------------------------
;	Fonctions de Convertion de Strings
;----------------------------------------------------------------------
Function charToInt%(s$)
	If (Asc(s)>=Asc(0))And(Asc(s)<=Asc(9)) Then
		Return Asc(s)-Asc("0")
	Else
		RuntimeError("'"+s+"' n'est pas un chiffre, impossible de convertir en Chiffre") 
	EndIf
End Function
;----------------------------------------------------------------------
Function StrToInt%(st$)
	If StrStartWith(st,"-") Then	;gestion du signe
		pow%=-1
		st=Right(st,Len(st)-1)
	Else 
		pow%=1
	EndIf
	res%=0
	fin=Len(St)
	For i=0 To fin-1
		res=res+ charToInt(Mid(st,fin-i,1))*pow
		pow=pow*10
	Next
	Return res
End Function
;----------------------------------------------------------------------
Function StrToFloat#(st$)
	If StrStartWith(st,"-") Then Local neg=True
	virgPos=Instr(st,".",1)
	If virgPos = 0 Then
		Return strToInt(st)
	Else
		ent# = strToInt(Left(st,virgPos-1))
		st = Right(st,Len(st)-virgPos)
		decim = strToInt(st)
		If neg Then decim=-decim
		Return ent+decim/(10^Len(st))
	EndIf
End Function
;----------------------------------------------------------------------
Function StrToBoolean(st$)
	Select (St$)
		Case "True" 
			Return True
		Case "False"
			Return False
		Default 
			RuntimeError("'"+ st +"' is not a boolean value." )
	End Select
	
End Function
;----------------------------------------------------------------------
Function StrGetValue$(st$)
	Local egalPos=Instr(st,"=")
	Return Right(st,Len(st)-egalPos) ;renvoie la valeur aprs le gale		
End Function
;----------------------------------------------------------------------
Function MilisecsToSt$(Mili#)
	Local Secs%=Int Mili/1000
	Return Secs/60+":"+Replace(RSet (Secs Mod 60,2)," ","0")
End Function
;----------------------------------------------------------------------
;	Fonctions graphiques
;----------------------------------------------------------------------
;transforme les coordones X (en pixel) de la souris en coordones sur le SpriteLayer
Function PixelXCoordToSpriteCoord#(x%) 
	Return (-0.5+Float X/ScreenWidth)*ScreenWidth/ScreenHeight*3/CurrentCameraZoom
End Function
;----------------------------------------------------------------------
;transforme les coordones Y (en pixel) de la souris en coordones sur le SpriteLayer
Function PixelYCoordToSpriteCoord#(Y%) 
	Return -(-0.5+Float Y/ScreenHeight)*3/CurrentCameraZoom
End Function

