;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;
Global camAngX#=0
Global camAngY#=30
Global camDist#=-60

Global camCentrX#=0
Global camCentrY#=20
Global camCentrZ#=10

Global camReplayDist#=-10

Global camBallAnglX#=0
Global camBallAnglY#=0

Global angleMode3#

Global gSensReplay%=1

;----------------------------------------------------------------
; M O V I N G   C A M E R A
;----------------------------------------------------------------
Function FUNC_UpdateCamera(mode%)
	Select (mode)
		Case 1 :
			UpdateCameraMode1()
		Case 2 : 
			UpdateCameraMode2()
		Case 3 : 
			UpdateCameraMode3()
		Case 4 : 
			UpdateCameraMode4()
    	Case 5 : 
			UpdateCameraMode5()
	End Select 
End Function
;----------------------------------------------------------------
;Met  jour l'angle de la camra en fonction des mouvement de la souris.
;----------------------------------------------------------------
Function FUNC_UpdateCameraAngleFromMouse()
	If MouseDown(2) Then
		;allow user to rotate camera
		camangX# = camangX# + decalMouseX*MouseSpeed
		camangY# = camangY# + decalMouseY*MouseSpeed
		MoveMouse MouseX()-decalMouseX,MouseY()-DecalMouseY ; on repalce la sourie l ou elle tait.
	EndIf
	camDist# = camDist# + decalMouseZ*MouseSpeed*10
End Function
;----------------------------------------------------------------
;----------------------------------------------------------------
;----------------------------------------------------------------
;  Camra centre sur la balle
;----------------------------------------------------------------
Function UpdateCameraMode1()
		FUNC_UpdateCameraAngleFromMouse()
		SetCameraZoom 1.7
		PositionEntity camera,EntityX(ball\mesh),EntityY(ball\mesh),EntityZ(ball\mesh)
		RotateEntity camera,camangY#,camangX#,0
		MoveEntity camera,0,0,camDist#
		TurnEntity camera,15,0,0
End Function
;----------------------------------------------------------------
;  Camra centre sur le plateau
;----------------------------------------------------------------
Function UpdateCameraMode2()
		FUNC_UpdateCameraAngleFromMouse()
		SetCameraZoom 1.7
		PositionEntity camera,camCentrX,camCentrY+camangY,camCentrZ
		RotateEntity camera,camangY#,camangX#,0
		MoveEntity camera,0,0,camDist#-camangY
		TurnEntity camera,15,0,0
		;Ne pas passer la camra sous le sol.
		If EntityY(Camera)<=1 Then PositionEntity(camera,EntityX(Camera),1,EntityZ(Camera))
End Function
;----------------------------------------------------------------
;  Camra Tourne au tour de la bille
;----------------------------------------------------------------
Function UpdateCameraMode3()
		SetCameraZoom 3
		PositionEntity Camera,EntityX(ball\mesh),EntityY(ball\mesh),EntityZ(ball\mesh)
		RotateEntity camera,45,angleMode3,0
		MoveEntity camera,0,0,camReplayDist
		;TurnEntity camera,15,0,0
		angleMode3=angleMode3+0.3
End Function
;----------------------------------------------------------------
;  Camra suis la bille en tournant au tour
;----------------------------------------------------------------
Function UpdateCameraMode4()
		SetCameraZoom 2
		
		Local yaw# = DeltaYaw(Camera,Ball\mesh)
		Local Pitch# = DeltaPitch(Camera,Ball\mesh)
		
		PositionEntity Camera,EntityX(ball\mesh),EntityY(ball\mesh),EntityZ(ball\mesh)
		
		camBallAnglX=camBallAnglX+Pitch
		camBallAnglY=camBallAnglY+Yaw+0.3
		
		RotateEntity Camera,45,camBallAnglY,0
		MoveEntity Camera,0,0,camReplayDist
End Function
;----------------------------------------------------------------
;  Camra suis la bille en tournant au tour par demis tours.
;----------------------------------------------------------------
Function UpdateCameraMode5()
		SetCameraZoom 2
		
		Local yaw# = DeltaYaw(Camera,Ball\mesh)
		Local Pitch# = DeltaPitch(Camera,Ball\mesh)
		
		PositionEntity Camera,EntityX(ball\mesh),EntityY(ball\mesh),EntityZ(ball\mesh)

		;sens pour les demis tour		
		If camBallAnglY<-80 Then gSensReplay=1
		If camBallAnglY>80 Then gSensReplay=-1
		
		camBallAnglX=camBallAnglX+Pitch
		camBallAnglY=camBallAnglY+Yaw+(0.3*gSensReplay)
		
		RotateEntity Camera,45,camBallAnglY,0
		MoveEntity Camera,0,0,camReplayDist
End Function
;----------------------------------------------------------------
;----------------------------------------------------------------
;----------------------------------------------------------------
;  Fonction de Gestion de la Camra Fluide
;----------------------------------------------------------------
Global CurrentCameraZoom#
Const ZoomStep#=0.01
Function SetCameraZoom(Zoom#)
	If Zoom<>CurrentCameraZoom Then
		If Zoom>CurrentCameraZoom Then CurrentCameraZoom=CurrentCameraZoom+ZoomStep
		If Zoom<CurrentCameraZoom Then CurrentCameraZoom=CurrentCameraZoom-ZoomStep
	EndIf
	CameraZoom(Camera,CurrentCameraZoom)
End Function