;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

Include "ODE Interface Functions.bb"
Include "Physics.bb"
Include "Object.bb"
Include "Util.bb"
Include "FileIO.bb"
Include "LoadObject.bb"
Include "Magnet.bb"
Include "ActionObject.bb"
Include "ActionObjectList.bb"
Include "AnimObject.bb"
Include "CheckPoint.bb"
Include "Ball.bb"
Include "FX.bb"
Include "Camera.bb"
Include "Config.bb"
Include "Mouse.bb"
Include "Game.bb"
Include "Sprite.bb"
Include "Menu.bb"
Include "Recorder.bb"
Include "Roms.bb"
Include "Sound.bb"
Include "SpriteString.bb"
Include "MainMenu.bb"
Include "HighScore.bb"
Include "FPS.bb"

AppTitle "Ball Game Emulator V"+Version

loadConfig()

Graphics3D ScreenWidth,ScreenHeight,0,FullScreen
HidePointer
SetBuffer BackBuffer()

;---------------------
; I N I T   O D E 
;----------------------
Global ODE_tempPivot = CreatePivot()
ODE_CreateWorld()
ODE_SetWorldGravity(-9.81)



;---------------------
; L I G H T S
;----------------------

light1=CreateLight() 
RotateEntity light1,45,0,0  
LightColor light1,120,120,120

light2=CreateLight() 
RotateEntity light2,125,0,0 
LightColor light2,150,150,150


;---------------------
; C A M E R A
;----------------------
Global camera=CreateCamera()
CameraZoom camera,1.7
CurrentCameraZoom = 1.7
Global SpriteLayer=CreatePivot(camera)
MoveEntity(SpriteLayer,0,0,2)

Global FrameTimer=CreateTimer(60)

;---------------------
; S O U N D S
;---------------------
InitSound()

;---------------------
; S P R I T E S
;---------------------
LoadGameSprite()


;---------------------
; M A I N   M E N U
;---------------------
Intro()
RomName$=ShowMainMenu()
FlushKeys()
;---------------------
; O B J E T S
;---------------------
If RomName<>""Then
	LoadRom(RomName)
	

	;;;;;;;;;;;;;;;;;;;
	update_all_objects()
	RenderWorld

	Run_Menu()
End If 
;bye bye
chnl=PlaySound(LoadSound("data\sfx\bye.wav"))
ChannelVolume(chnl,SfxVolume)
While ChannelPlaying(chnl)
Wend

End