;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

Global StaticID_OdeObject=1
Global StaticID_OdeJoint=1
Global Coef#=5 

;tableau d'objets actifs qui doivent tre mis  jours tout le temps.
Global TabActiveObjectCol.ODE_Object[3]
Global NbActiveObjectCol%=0

;----------------------------------------------------------------------
; Objet : TObjectCol
; Description : permet d'associer  un objet complexe de type 3DS ou autre 
;		un ou plusieurs paralllpipdes pour simuler sa collision
;----------------------------------------------------------------------
Type TObjectCol
	Field ObjetName$
	Field x#,y#,z#
	Field Mesh%
	Field NumObjectCol%
	Field TabObjectCol.ODE_Object[25]
	Field CoefMovX#,CoefMovY#,CoefMovZ#,CoefAngleMovX#,CoefAngleMovY#,CoefAngleMovZ#
	Field geomOnly ; = False alors l'objet est soumis au loie de la physique de son environement.
End Type 

;----------------------------------------------------------------------
Function PositionObjectCol(objC.TObjectCol,x#,y#,z#)
	PositionEntity(objC\mesh,objC\x+x,objC\y+y,objC\Z+Z)
	
	For i%=0 To objC\NumObjectCol-1
		Local odeObj.ODE_Object=objC\TabObjectCol[i]
		ODE_PositionObject(odeObj\ODE_ID,odeObj,odeObj\Xorig+objC\x+x,odeObj\Yorig+objC\y+y,odeObj\Zorig+objC\z+z)
	Next
End Function
;----------------------------------------------------------------------
Function RotateObjectCol(objC.TObjectCol,x#,y#,z#)
	RotateEntity(objC\mesh,x,y,z)
	
	For i%=0 To objC\NumObjectCol-1
		Local odeObj.ODE_Object=objC\TabObjectCol[i]
		
		ODE_RotateObject(odeObj\Ode_ID,odeObj,odeObj\XAorig+DegToRad(x),odeObj\YAorig-DegToRad(y),odeObj\ZAorig+DegToRad(z))
		;---------------
		TFormVector(odeObj\Xorig,odeObj\Yorig,odeObj\Zorig,objC\mesh,0)
		Local Xmov#=TFormedX()/Coef
		Local Ymov#=TFormedY()/Coef
		Local Zmov#=TFormedZ()/Coef		
		ODE_PositionObject(odeObj\Ode_ID,odeObj,objC\x+Xmov,objC\y+Ymov,objC\z+Zmov)
		;---------------
	Next
End Function
;----------------------------------------------------------------------
;   Replace les objets Libres (not geomOnly)  leur position d'origine.
;----------------------------------------------------------------------
Function ResetFreeObjet()
	For obj.TObjectCol= Each TObjectCol
		If Not obj\geomOnly Then 
			Local odeObj.ODE_Object=obj\TabObjectCol[0]
			
			;positionement de l'objet  sa place d'origine
			ODE_PositionObject(odeObj\Ode_ID,odeObj,obj\x+odeObj\Xorig,obj\y+odeObj\Yorig,obj\z+odeObj\Zorig)
			
			;rotation de l'objet  sa position d'origine
			ODE_RotateObject(odeObj\Ode_ID,odeObj,odeObj\XAorig,odeObj\YAorig,odeObj\ZAorig)

			ODE_SetBodyAngularVelocity(odeObj\Ode_ID,0,0,0)
			ODE_SetBodyLinearVelocity(odeObj\Ode_ID,0,0,0)
		EndIf
	Next
End Function