;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

Global SP_Progress%
Global SP_ProgressBarCursor%
Global RomPath$
Global ReplayMode%

Const Version$="1.1"

Function LoadRom(Path$)
	RomPath=Path
	
	Local fich=ReadFile(path+"\Rom.desc")
		
		;Vrification de la compatibilit de la Rom
		file_gotoSection(fich,"VersionCompatibility")
			If file_ReadString(fich)<>Version Then RuntimeError("Rom Vertion Not Compatible with the Version "+Version)
						
	
		;Chargement des CheckPoints
		file_gotoSection(fich,"CheckPoints")
			LoadCheckPoints(path+"\"+file_ReadString(fich))
			
		;Chargement des SoundOx
		If file_SeekSection(fich,"SoundBox") Then
			LoadSoundBox(path+"\"+file_ReadString(fich))
		EndIf
			
		;Chargement de la bille
		file_gotoSection(fich,"Ball")
			RayonSphere=file_ReadFloat(fich)
			CreateBall()

		;Chargement de la Camera
		file_gotoSection(fich,"Camera")
			camCentrX=file_ReadFloat(fich)
			camCentrY=file_ReadFloat(fich)
			camCentrZ=file_ReadFloat(fich)
			camAngX=file_ReadFloat(fich)
			camAngY=file_ReadFloat(fich)
			camDist=file_ReadFloat(fich)
			camReplayDist=file_ReadFloat(fich)
			ReplayMode=file_ReadInt(fich)

		;Chargement des boutons
		file_gotoSection(fich,"ActionObject")
			Local AobFich$=file_ReadString(fich)
			While AobFich<>"[end]"
				loadActionObject(path+"\"+AobFich)
				AobFich$=file_ReadString(fich)
			Wend
		
		;Chargement des objets anims.
		If file_SeekSection(fich,"AnimObject") Then
			Local AnOFich$=file_ReadString(fich)
			While AnOFich<>"[end]"
				loadAnimObject(path+"\"+AnOFich)
				AnOFich$=file_ReadString(fich)
			Wend
		EndIf 
		
		;Chargement des Autes objets
		file_gotoSection(fich,"ObjectCol")
			Local ObColFich$=file_ReadString(fich)
			While ObColFich<>"[end]"
				loadObject(path+"\"+ObColFich)
				ObColFich$=file_ReadString(fich)
			Wend
		
		
		;Chargement des Sprites
		file_gotoSection(fich,"Sprites")
			If (Cfg_Ground) Then
				;Chargement du Sol
				Local GroundTexture = LoadTexture(path+"\"+file_ReadString(fich),8)
				ScaleTexture(GroundTexture,50,50) 
				Local Groung= CreatePlane()
				EntityTexture Groung,GroundTexture 
			Else
				file_ReadString(fich);on avance d'une ligne dans le fichier Texte
			End If
			
			;Sky Box
			Local skyBox=CreateCube()
			ScaleEntity(skyBox,500,500,500)
			FlipMesh(skyBox)
			EntityOrder(skyBox,10)
			EntityFX(skyBox,1)
			Local skyTexture=LoadTexture(path+"\"+file_ReadString(fich),8)
			EntityTexture(skyBox,skyTexture)
			
			;Barre de Progression
			SP_Progress=SpLoadSprite(path+"\"+file_ReadString(fich),inGameSpLayer)
			ScaleSprite(SP_Progress,1,0.07)
			MoveEntity SP_Progress,0,-.8,0

			
			
			;Cursor de barre de progression
			SP_ProgressBarCursor=SpLoadSprite(path+"\"+file_ReadString(fich),inGameSpLayer)
			ScaleSprite( SP_ProgressBarCursor,0.05,0.05)
			EntityOrder ( SP_ProgressBarCursor,-2)	
			
		
	CloseFile(fich)
	
	;chargement du high Score.
	LoadHighScore$()
End Function